﻿Option Infer Off
Option Strict On
Option Explicit On

Imports System

''' <summary>
''' Ein beschreibendes Attribut für mathematische Funktionen
''' </summary>
''' <remarks></remarks>
<AttributeUsage(AttributeTargets.Method)> _
Public Class MathFuncAttribute : Inherits Attribute
    Private ReadOnly mName As String
    Private ReadOnly mStandardCoefficients As IEnumerable(Of Double)

    Public Sub New(ByVal Name As String, ByVal ParamArray StandardCoefficients() As Double)
        mName = Name
        mStandardCoefficients = StandardCoefficients
    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return mName
        End Get
    End Property


    Public ReadOnly Property Coefficients() As IEnumerable(Of Double)
        Get
            Return mStandardCoefficients
        End Get
    End Property
End Class