﻿Public Class MathFunctionView

    Public Buffer As Bitmap ' wird neu gezeichnet

    Private mAxis As Bitmap ' statisch
    Private mMtrx As Drawing2D.Matrix
    Private mSize As Size

    Public WriteOnly Property Size() As Size
        Set(ByVal value As Size)
            mSize = value
            mMtrx = New System.Drawing.Drawing2D.Matrix()

            With mSize
                mMtrx.Translate(.Width \ 2, .Height \ 2)
                mMtrx.Scale(1.0F, -1.0F) ' (2.0F, -2.0F)
            End With

            DrawAxis()

        End Set

    End Property

    Private Sub DrawAxis()

        With mSize
            mAxis = New Bitmap(.Width, .Height)

            Dim gr As Drawing.Graphics = Graphics.FromImage(mAxis)

            gr.DrawLine(Pens.Black, New Point(0, .Height \ 2), New Point(.Width, .Height \ 2))
            gr.DrawLine(Pens.Black, New Point(.Width \ 2, 0), New Point(.Width \ 2, .Height))
        End With

    End Sub

    Public Sub DrawFunction(ByVal f As MathFunction)

        Buffer = New Bitmap(mAxis)

        Dim xMin As Double = -mSize.Width \ 2
        Dim xMax As Double = Math.Abs(xMin)
        Dim x, y As Double
        Dim newPt, oldPt As Point
        Dim gr As Drawing.Graphics = Graphics.FromImage(Buffer)

        gr.Transform = mMtrx

        If f Is Nothing Then Exit Sub

        Try

            For x = xMin To xMax
                y = f(x) ' so hier ist also jetzt endlich das y = f(x), einfacher wirds nicht
                newPt = New Point(CInt(x), CInt(y))

                If x = xMin Then oldPt = newPt ' noch bevor gezeichnet wird!
                gr.DrawLine(Pens.Blue, oldPt, newPt)
                oldPt = newPt
            Next

        Catch

            '
        End Try

    End Sub
End Class
