﻿Option Infer Off
Option Strict On
Option Explicit On

Imports System.Reflection
Imports System.Runtime.CompilerServices

<HideModuleName()> _
Public Module ReflectFunctions

    ''' <summary>
    ''' Funktionen einlesen
    ''' </summary>
    ''' <param name="Dictionary"></param>
    ''' <param name="FuncContainer"></param>
    ''' <remarks></remarks>
    <Extension()> _
    Sub ReflectFunctions(ByVal Dictionary As Dictionary(Of String, MathFunction), ByVal FuncContainer As Functions)
        Dim TypeOfContainer As Type = GetType(Functions)

        ' Methoden durchlaufen
        For Each Method As MethodInfo In TypeOfContainer.GetMethods()

            ' Attribut rauskramen

            ' Original mit Linq
            ' Dim MathAttr As MathFunc = DirectCast((From Attr As Attribute In Attribute.GetCustomAttributes(Method) Where TypeOf Attr Is MathFunc Select Attr).FirstOrDefault, MathFunc)

            ' Besser (von 'Spatzenkanonier')
            Dim MathAttr As MathFuncAttribute = Attribute.GetCustomAttributes(Method).OfType(Of MathFuncAttribute).FirstOrDefault

            Dim temp As MethodInfo = Method ' Warnung vermeiden

            If MathAttr IsNot Nothing Then
                Dictionary.Add(MathAttr.Name, Function(x As Double) Invoker(temp, MathAttr, FuncContainer, x))
            End If
        Next

    End Sub

    Private Function Invoker(ByVal Method As MethodInfo, ByVal Attr As MathFuncAttribute, ByVal FuncContainer As Functions, ByVal x As Double) As Double
        FuncContainer.C = New List(Of Double)(Attr.Coefficients)
        Return CDbl(Method.Invoke(FuncContainer, New Object() {x}))
    End Function

End Module
